/*  DeltaSMT: Delta-debugger for Satisfiablity Modulo Theories (SMT) benchmarks.
 *  Copyright (C) 2009  Robert Daniel Brummayer
 *
 *  This file is part of DeltaSMT.
 *
 *  DeltaSMT is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DeltaSMT is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class Extract extends IndexedUnaryBVNode
{

  protected int value2;

  public Extract (BVType type, SMTNode n, int value1, int value2){
    super (SMTNodeKind.EXTRACT, type, n, value1);

    assert (kind != null);
    assert (type != null);
    assert (n != null);
    assert (n.getType() instanceof BVType);
    assert (value1 >= value2);
    assert (value2 >= 0);

    this.value2 = value2;
  }

  public int getValue2(){
   return this.value2;
  }

  public int getUpper(){
    return super.value1;
  }

  public int getLower(){
    return this.value2;
  }

  public String toString(){
    return "extract[" + super.value1 + ":" + this.value2 + "]";
  }

  public String hashKey(){
    return super.hashKey() + " " + this.value2;
  }

}
