/*  DeltaSMT: Delta-debugger for Satisfiablity Modulo Theories (SMT) benchmarks.
 *  Copyright (C) 2009  Robert Daniel Brummayer
 *
 *  This file is part of DeltaSMT.
 *
 *  DeltaSMT is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DeltaSMT is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class IndexedUnaryBVNode extends SMTNode {

  protected int value1;

  public IndexedUnaryBVNode (SMTNodeKind kind, BVType type, SMTNode n, 
                             int value1){
    super (kind, type, n);

    assert (kind != null);
    assert (type != null);
    assert (n != null);
    assert (n.getType() instanceof BVType);
    assert (value1 >= 0);
    assert (SMTNodeKind.isIndexedUnaryKind(kind));

    this.value1 = value1;
  }

  public int getValue1 (){
    return this.value1;
  }

  public String toString(){
    return super.kind.getString() + "[" + this.value1 + "]";
  }

  public String hashKey(){
    return super.kind.toString() + " " + super.children[0].id + " " + 
           this.value1;
  }

}
